VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   3195
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   3195
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
   Begin VB.Timer tmrDraw 
      Enabled         =   0   'False
      Interval        =   1
      Left            =   1920
      Top             =   120
   End
   Begin VB.PictureBox picCanvas 
      Height          =   2535
      Left            =   120
      ScaleHeight     =   2475
      ScaleWidth      =   4395
      TabIndex        =   1
      Top             =   600
      Width           =   4455
   End
   Begin VB.CommandButton cmdPlayBack 
      Caption         =   "Play Back"
      Height          =   375
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   1095
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Declare Function ClientToScreen Lib "user32" (ByVal hwnd As Long, lpPoint As POINTAPI) As Long
Private Type POINTAPI
    X As Long
    Y As Long
End Type

Private Declare Sub mouse_event Lib "user32" (ByVal dwFlags As Long, ByVal dx As Long, ByVal dy As Long, ByVal cButtons As Long, ByVal dwExtraInfo As Long)

Private Const MOUSEEVENTF_MOVE = &H1          ' mouse move
Private Const MOUSEEVENTF_LEFTDOWN = &H2      ' left button down
Private Const MOUSEEVENTF_LEFTUP = &H4        ' left button up
Private Const MOUSEEVENTF_RIGHTDOWN = &H8     ' right button down
Private Const MOUSEEVENTF_RIGHTUP = &H10      ' right button up
Private Const MOUSEEVENTF_MIDDLEDOWN = &H20   ' middle button down
Private Const MOUSEEVENTF_MIDDLEUP = &H40     ' middle button up
Private Const MOUSEEVENTF_WHEEL = &H800       ' wheel button rolled
Private Const MOUSEEVENTF_ABSOLUTE = &H8000   ' absolute move

Private m_Drawing As Boolean
Private m_NumPoints As Integer
Private m_PointData() As PointData
Private m_LastPoint As Integer
Private Sub cmdPlayBack_Click()
    If m_NumPoints < 2 Then Exit Sub
    cmdPlayBack.Enabled = False

    picCanvas.Cls
    m_LastPoint = 2
    tmrDraw.Enabled = True
End Sub


Private Sub Form_Load()
    picCanvas.ScaleMode = vbPixels
    picCanvas.AutoRedraw = True
End Sub


Private Sub picCanvas_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    picCanvas.Cls
    m_Drawing = True
    m_NumPoints = 1
    ReDim m_PointData(1 To m_NumPoints)
    Set m_PointData(1) = New PointData
    m_PointData(1).X = X
    m_PointData(1).Y = Y
    m_PointData(1).TheTime = Now
End Sub


Private Sub picCanvas_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    If Not m_Drawing Then Exit Sub

    m_NumPoints = m_NumPoints + 1
    ReDim Preserve m_PointData(1 To m_NumPoints)

    Set m_PointData(m_NumPoints) = New PointData
    m_PointData(m_NumPoints).X = X
    m_PointData(m_NumPoints).Y = Y
    m_PointData(m_NumPoints).TheTime = Now

    picCanvas.Line (m_PointData(m_NumPoints - 1).X, m_PointData(m_NumPoints - 1).Y)-(X, Y)
End Sub


Private Sub picCanvas_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    m_Drawing = False
End Sub

Private Sub tmrDraw_Timer()
Dim pt As POINTAPI
Dim X As Long
Dim Y As Long
Dim new_interval As Long

    picCanvas.Line _
        (m_PointData(m_LastPoint - 1).X, m_PointData(m_LastPoint - 1).Y)- _
        (m_PointData(m_LastPoint).X, m_PointData(m_LastPoint).Y)

    ' Convert the next point into screen coordinates.
    pt.X = m_PointData(m_LastPoint).X
    pt.Y = m_PointData(m_LastPoint).Y
    ClientToScreen picCanvas.hwnd, pt

    ' mouse_event moves in a coordinate system where
    ' (0, 0) is in the upper left corner and
    ' (65535,65535) is in the lower right corner.
    ' Convert into this coordinate system.
    X = pt.X * 65535 / ScaleX(Screen.Width, vbTwips, vbPixels)
    Y = pt.Y * 65535 / ScaleY(Screen.Height, vbTwips, vbPixels)

    ' Move the mouse.
    mouse_event _
        MOUSEEVENTF_ABSOLUTE + _
        MOUSEEVENTF_MOVE, _
        X, Y, 0, 0

    ' See if this was the last point.
    m_LastPoint = m_LastPoint + 1

    tmrDraw.Enabled = False
    If m_LastPoint >= m_NumPoints Then
        cmdPlayBack.Enabled = True
    Else
        new_interval = _
            (m_PointData(m_LastPoint).TheTime - _
             m_PointData(m_LastPoint - 1).TheTime)
        If new_interval < 1 Then new_interval = 1
        tmrDraw.Interval = new_interval
        tmrDraw.Enabled = True
    End If
End Sub

